// psdsensor.ino
//
// 距離を測る（測距モジュール使用）
// 
// Written by Nobuki HIRAMINE
// Last modified : 2011/12/03

#include <LiquidCrystal.h>

#define SENSORPIN	(0)
#define THRESHOLD	(80)

LiquidCrystal lcd( 12, 11, 5, 4, 3, 2 );

void setup()
{
	lcd.begin( 16, 2 );
	lcd.clear();
}

void loop()
{
	int iValue = analogRead( SENSORPIN );

	double dDistance = 0.0;	
	if( THRESHOLD < iValue )
	{
		dDistance = 6768.0 / (iValue - 3.0) - 4.0;
	}
	
	lcd.clear();
	lcd.setCursor( 0, 0 );
	if( 0.0 == dDistance )
	{
		lcd.print( "Far" );
	}
	else if( 10 > dDistance )
	{
		lcd.print( "Near" );
	}
	else
	{
		lcd.print( dDistance );
		lcd.print( "[cm]" );
	}
	
	delay( 1000 );
}
